/***************************************************************************
 *              Filename : CurveWindow.h
 *                   Begin : 2008-08-14 08:46:43
 *                 Project : CurveWindow
 *                  Author : Wu Yin
 ***************************************************************************/
#include <iostream>
#include <gtk/gtk.h>
 using namespace std;

 class CurveWindow
 {
	 public:
		 CurveWindow(){};
		 GtkWidget *create_drawing_win();
		 GtkWidget *get_root_widget();
		 int draw();
		 GdkPixmap *pixmap;
 
	 private:
		 GtkWidget *drawing;
 };
//========================================================


/* Create a new backing pixmap of the appropriate size */
static gboolean configure_event( GtkWidget *widget, GdkEvent *event, gpointer data)
{
	CurveWindow *self = (CurveWindow *)data;
	GdkColor color;
	GdkGC *gc = gdk_gc_new(widget->window);

	self->pixmap = gdk_pixmap_new(widget->window,
			widget->allocation.width,
			widget->allocation.height,
			-1);
	// Draw the background
	gdk_draw_rectangle (self->pixmap,
			widget->style->white_gc,
			TRUE,
			0, 0,
			widget->allocation.width,
			widget->allocation.height);
	return TRUE;
}

/***************************************************************************
 * add by Wu Yin, 2008-08-14 08:55:09
 ***************************************************************************/
static gboolean redraw(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
printf("expose-event \n");
	CurveWindow *self = (CurveWindow *)data;
	gdk_draw_drawable (widget->window,
			widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
			self->pixmap,
			event->area.x, event->area.y,
			event->area.x, event->area.y,
			event->area.width, event->area.height);
	return TRUE;
}

/***************************************************************************
 * add by Wu Yin, 2008-08-19
 ***************************************************************************/
int CurveWindow::draw()
{
	GtkWidget *widget = this->get_root_widget();
	static int y = 0;

	y += 10;
	gdk_draw_line(pixmap, 
		widget->style->fg_gc[GTK_WIDGET_STATE(widget)],
		0, 0, 120, y);
	gtk_widget_draw(widget, NULL);
	return 0;
}

/***************************************************************************
 * add by Wu Yin, 2008-08-14 08:55:09
 ***************************************************************************/
GtkWidget *CurveWindow::get_root_widget()
{
	return drawing;
}

/***************************************************************************
 * add by Wu Yin, 2008-08-14 08:55:09
 ***************************************************************************/
GtkWidget *CurveWindow::create_drawing_win()
{
	drawing = gtk_drawing_area_new();
	g_signal_connect(G_OBJECT(drawing), "expose-event",
			G_CALLBACK(redraw), this);
	g_signal_connect (G_OBJECT (drawing),"configure_event",
			G_CALLBACK (configure_event), this);
	return drawing;
}

